﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Calculate;
using Syncfusion.Windows.Forms.Grid;

namespace DynamicFormula
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            List<MyMath> list = new List<MyMath>();
            list.Add(new MyMath() { A = 2.1, B = 3, C = 4.5 });
            list.Add(new MyMath() { A = 3.4, B = 4, C = 3.7 });
            list.Add(new MyMath() { A = 2.7, B = 1, C = 5.3 });
            list.Add(new MyMath() { A = 3.7, B = 2, C = 7.1 });
            list.Add(new MyMath() { A = 4.8, B = 6, C = 2.9 });
            this.gridGroupingControl1.DataSource = list;
            this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            GridFormulaEngine formulaEngine = new GridFormulaEngine(this.gridGroupingControl1.TableModel);

            foreach (GridRecord rec in this.gridGroupingControl1.Table.Records)
            {
                double aValue = (double)rec["A"];
                int bValue = (int)rec["B"];
                double cValue = (double)rec["C"];
                if (rec["Formula"] != null)
                {
                    string formula = rec["Formula"].ToString();
                    //Replacing the given expesson with values.
                    if (formula.Contains('a'))
                        formula = formula.Replace("a", aValue.ToString());
                    if (formula.Contains('b'))
                        formula = formula.Replace("b", bValue.ToString());
                    if (formula.Contains("c"))
                        formula = formula.Replace("c", cValue.ToString());
                    string result = formulaEngine.ComputeFormulaText(formula);
                    rec.SetValue("Result", result);
                }
            }
        }
    }
}
